local UIConfig = CreateFrame("Frame", "MOTSHframe", UIParent, "UIPanelDialogTemplate");
UIConfig:SetMovable(true);
UIConfig:EnableMouse(true);
UIConfig:RegisterForDrag("LeftButton");
UIConfig:SetScript("OnDragStart", UIConfig.StartMoving);
UIConfig:SetScript("OnDragStop", UIConfig.StopMovingOrSizing);
UIConfig:SetSize(352,201);
UIConfig:SetPoint("TOP", UIParent, "TOP",300,0);
UIConfig:SetShown(false);
UIConfig:RegisterEvent("CHAT_MSG_ADDON");
C_ChatInfo.RegisterAddonMessagePrefix("MOTSH")
UIConfig:RegisterEvent("GROUP_ROSTER_UPDATE");
--UIConfig:RegisterEvent("PLAYER_ENTERING_WORLD");
UIConfig:RegisterEvent("BOSS_KILL");
UIConfig:RegisterEvent("ADDON_LOADED");
UIConfig:SetScript('OnEvent', function(self, event, arg1, arg2, ...) --https://wow.gamepedia.com/DungeonEncounterID,, https://wow.gamepedia.com/Events
    if event == "ADDON_LOADED" and arg1 == "MistsOfTirnaScitheHelper" then
        if isAnnounce == nil then
            isAnnounce = true;       
        end
        if isAnnounce then
            announceButton:SetText("Announce [ON] OFF");
        else
            announceButton:SetText("Announce ON [OFF]");
        end
    end
    if (event == "BOSS_KILL" and arg1 == 2397) then --Ingra Maloch
        --print("|cff0000ffMOTSH|r |cffFF4500Ingra Maloch Killed. Type /motsh to show this addon if not already showing|r");
        UIConfig:SetShown(true);
    elseif (event == "BOSS_KILL" and arg1 == 2392) then --Mistcaller
        --print("|cff0000ffMOTSH|r |cffFF4500Mistcaller Killed. Type /motsh to hide this addon if not already hidden|r");
        UIConfig:SetShown(false);
    end
    --[[if (event == "PLAYER_ENTERING_WORLD" ) then
        local isInstance, instanceType = IsInInstance();
        if (isInstance == true and ((instanceType == "party") or (instanceType == "raid"))) then
            local instanceName, instanceType, difficultyID, difficultyName, maxPlayers, dynamicDifficulty,
                    isDynamic, instanceID, instanceGroupSize, LfgDungeonID = GetInstanceInfo();
            if (instanceName == "Mists of Tirna Scithe") then
                UIConfig:SetShown(true);
            end
        else
            UIConfig:SetShown(false);
        end
    end]]--
    if event == ("CHAT_MSG_ADDON") then
        if arg1 == "MOTSH" then
            --print("test")
            local indexCommunicated = arg2
            if indexCommunicated ~= nil and tonumber(indexCommunicated) then
                updateUI(tonumber(indexCommunicated));
            elseif indexCommunicated ~= nil and indexCommunicated == "reset" then
                reset();
            elseif indexCommunicated ~= nil and indexCommunicated == "reset" then
            end

        end
    end
    if event == ("GROUP_ROSTER_UPDATE") then
        reset();
    end
end
);

local count = 0;
local winner = 0;

local announceButton = CreateFrame("Button", "announceButton", UIConfig, "UIPanelButtonTemplate");
announceButton:SetWidth(150);
announceButton:SetHeight(20);
announceButton:SetPoint("TOPLEFT", UIConfig,"TOPLEFT", 7, -5);

announceButton:SetScript("OnClick", function(self)

    isAnnounce = not isAnnounce;    
    if isAnnounce then
        announceButton:SetText("Announce [ON] OFF");
        if checkKey(count) ~= 0 then
            printWinner();
        end
    else
        announceButton:SetText("Announce ON [OFF]");
    end
end
);

local resetButton = CreateFrame("Button", "resetButton", UIConfig, "UIPanelButtonTemplate");
resetButton:SetWidth(80);
resetButton:SetHeight(20);
resetButton:SetPoint("TOPRIGHT", UIConfig,"TOPRIGHT", -27, -5);
resetButton:SetText("Reset");

resetButton:SetScript("OnClick", function(self)
    if GetNumGroupMembers() == 0 then
        reset();
    else
        C_ChatInfo.SendAddonMessage("MOTSH", "reset", InstanceOrParty());
        C_ChatInfo.SendAddonMessage('MAZEHELPER', 'SendReset', InstanceOrParty()); --MazeHelper Compatibility!  
    end 
end
);


--[[

RING
0 - yes
1 - no

FORM
0 - flower
1 - leaf

FILL
0 - empty
1 - full


]]--
local table = 
{
    {
        id = 1,

        ring = 0;
        form = 0;
        fill = 0;

        selected = false;
    },
    {
        id = 2;

        ring = 0;
        form = 0;
        fill = 1;

        selected = false;
    },
    {
        id = 3,

        ring = 0;
        form = 1;
        fill = 0;

        selected = false;
    },
    {
        id = 4,
        
        ring = 0;
        form = 1;
        fill = 1;

        selected = false;
    },
    {
        id = 5,

        ring = 1;
        form = 0;
        fill = 0;

        selected = false;
    },
    {
        id = 6,

        ring = 1;
        form = 0;
        fill = 1;

        selected = false;
    },
    {
        id = 7,

        ring = 1;
        form = 1;
        fill = 0;

        selected = false;
    },
    {
        id = 8,

        ring = 1;
        form = 1;
        fill = 1;

        selected = false;
    }
}

local buttonID_MH = {
    [1] = 4,
    [2] = 3,
    [3] = 2,
    [4] = 1,
    [5] = 8,
    [6] = 7,
    [7] = 6,
    [8] = 5,
};


function addButtons()
    local ypos = -25;
    local xpos = 7;
    
    for i = 1, 8 do

        if i == 5  then
            ypos = -108;
            xpos = 7;
        end
        
        local backdrop = CreateFrame("Frame", "backdrop" .. i, UIConfig, BackdropTemplateMixin and "BackdropTemplate")
        backdrop:SetPoint("TOPLEFT", UIConfig, "TOPLEFT", xpos, ypos);
        backdrop:SetWidth(85);
        backdrop:SetHeight(85);
        backdrop:SetBackdrop({
            --bgFile = "Interface/Tooltips/UI-Tooltip-Background",
            edgeFile = "Interface/Tooltips/UI-Tooltip-Border",
            edgeSize = 30,
            --insets = { left = 4, right = 4, top = 4, bottom = 4 },
        })
        backdrop:SetBackdropBorderColor(0, 0, 0, 0);
        local button = CreateFrame("Button", "button" .. i, backdrop, "BackdropTemplate");
        button:SetWidth(75);
        button:SetHeight(75);
        button:SetPoint("CENTER",backdrop,"CENTER");
        button:SetNormalTexture("Interface/AddOns/MistsOfTirnaScitheHelper/Images/" .. i);
        button:SetPushedTexture("Interface/AddOns/MistsOfTirnaScitheHelper/Images/" .. i);
        --button:SetHighlightTexture("Interface/AddOns/MistsOfTirnaScitheSmartSolve/Images/" .. i);
        button:SetScript("OnClick", function(self)
            sendClick(i)
        end
        );
        xpos = xpos + 85;
    end
end

addButtons();

function updateUI(index)
    local skipThisIteration = false;
    local blackTable = {0, 0, 0, 0};
    local redTable = {1, 0, 0, 1};
    local greenTable = {0, 1, 0, 1};
    local f = _G["button" .. index]:GetParent()
    table[index].selected = not table[index].selected;
    local red, green, blue, alpha = f:GetBackdropBorderColor()
    red = tonumber(string.format("%.3f", red));
    green = tonumber(string.format("%.3f", green));
    blue = tonumber(string.format("%.3f", blue));
    alpha = tonumber(string.format("%.3f", alpha));
    local bdbc = {red, green , blue, alpha};
    if listCompare(bdbc, blackTable) then
        f:SetBackdropBorderColor(1, 0, 0, 1);
        count = count + 1;
        if winner ~= 0 then
            _G["backdrop".. winner]:SetBackdropBorderColor(1, 0, 0, 1);
        end
    elseif listCompare(bdbc, redTable) then
        f:SetBackdropBorderColor(0, 0, 0, 0);
        count = count - 1;
        if winner ~= 0 then
            _G["backdrop".. winner]:SetBackdropBorderColor(1, 0, 0, 1);
        end
    elseif listCompare(bdbc, greenTable) then
        f:SetBackdropBorderColor(0, 0, 0, 0);
        count = count - 1;
        if count == 3 then
            skipThisIteration = true;
            winner = 0;
        end
    end
    
    if not skipThisIteration then
        winner = checkKey(count);
        if winner ~= 0 then
            _G["backdrop".. winner]:SetBackdropBorderColor(0, 1, 0, 1);
            if isAnnounce then
                printWinner();
            end
        end
    end
end

function listCompare(list1, list2)
    for k = 1, 4 do
        if list1[k] ~= list2[k] then
            return false;
        end
    end
    return true;
end

function printWinner()
    for index, value in pairs(table) do
        if value.id == winner then
            local ringS, formS, fillS;
            if value.ring == 1 then
                ringS = "NO RING";
            else
                ringS = "RING";
            end

            if value.form == 1 then
                formS = "LEAF";
            else
                formS = "FLOWER";
            end

            if value.fill == 1 then
                fillS = "FILLED";
            else
                fillS = "EMPTY";
            end
            --SendChatMessage("|cff0000ffMOTSH|r |cffFF4500Correct Combination is: [" .. ringS .. "], [" .. formS .. "], [" .. fillS .. "]|r", "PARTY")
            SendChatMessage("MOTSH Correct Combination is: [" .. ringS .. "], [" .. formS .. "], [" .. fillS .. "]", InstanceOrParty());
            --print("|cff0000ffMOTSH|r |cffFF4500Correct Combination is: [" .. ringS .. "], [" .. formS .. "], [" .. fillS .. "]|r")
        end
    end
end

function copy1(obj)
    if type(obj) ~= 'table' then return obj end
    local res = {};
    for k, v in pairs(obj) do res[copy1(k)] = copy1(v); end
    return res;
end

function checkKey(counter)
    local returnID;
    local found = 0;
    if counter == 4 then
        local list = {};
        local j = 1;
        for i = 1, 8 do
            if table[i].selected == true then
                list[j] = copy1(table[i]);
                j = j+1;
            end
        end
        local sumRing = list[1].ring + list[2].ring + list[3].ring + list[4].ring;
        local sumForm = list[1].form + list[2].form + list[3].form + list[4].form;
        local sumFill = list[1].fill + list[2].fill + list[3].fill + list[4].fill;
        if sumRing == 1 then
            if list[1].ring == 1 then returnID = list[1].id; found = found + 1;
            elseif list[2].ring == 1 then returnID = list[2].id; found = found + 1;
            elseif list[3].ring == 1 then returnID = list[3].id; found = found + 1;
            elseif list[4].ring == 1 then returnID = list[4].id; found = found + 1;
            end
        end
        if sumForm == 1 then
            if list[1].form == 1 then returnID = list[1].id; found = found + 1;
            elseif list[2].form == 1 then returnID = list[2].id; found = found + 1;
            elseif list[3].form == 1 then returnID = list[3].id; found = found + 1;
            elseif list[4].form == 1 then returnID = list[4].id; found = found + 1;
            end
        end
        if sumFill == 1 then
            if list[1].fill == 1 then returnID = list[1].id; found = found + 1;
            elseif list[2].fill == 1 then returnID = list[2].id; found = found + 1;
            elseif list[3].fill == 1 then returnID = list[3].id; found = found + 1;
            elseif list[4].fill == 1 then returnID = list[4].id; found = found + 1;
            end
        end
        if sumRing == 3 then
            if list[1].ring == 0 then returnID = list[1].id; found = found + 1;
            elseif list[2].ring == 0 then returnID = list[2].id; found = found + 1;
            elseif list[3].ring == 0 then returnID = list[3].id; found = found + 1;
            elseif list[4].ring == 0 then returnID = list[4].id; found = found + 1;
            end
        end
        if sumForm == 3 then
            if list[1].form == 0 then returnID = list[1].id; found = found + 1;
            elseif list[2].form == 0 then returnID = list[2].id; found = found + 1;
            elseif list[3].form == 0 then returnID = list[3].id; found = found + 1;
            elseif list[4].form == 0 then returnID = list[4].id; found = found + 1;
            end
        end
        if sumFill == 3 then
            if list[1].fill == 0 then returnID = list[1].id; found = found + 1;
            elseif list[2].fill == 0 then returnID = list[2].id; found = found + 1;
            elseif list[3].fill == 0 then returnID = list[3].id; found = found + 1;
            elseif list[4].fill == 0 then returnID = list[4].id; found = found + 1;
            end
        end
    elseif counter == 3 then
        local list = {};
        local j = 1;
        for i = 1, 8 do
            if table[i].selected == true then
                list[j] = copy1(table[i]);
                j = j+1;
            end
        end

        returnID = checkThrees(list[1], list[2], list[3])
        if returnID == 0 then
            returnID = checkThrees(list[2], list[3], list[1])
        end
        if returnID == 0 then
            returnID = checkThrees(list[3], list[1], list[2])
        end
        if returnID ~= 0 then
            return returnID;
        else
            local answerRing, answerForm, answerFill;
            local sumRing = list[1].ring + list[2].ring + list[3].ring
            local sumForm = list[1].form + list[2].form + list[3].form
            local sumFill = list[1].fill + list[2].fill + list[3].fill

            if sumRing == 3 or sumRing == 2 then answerRing = 0;
            elseif sumRing == 0 or sumRing == 1 then answerRing = 1; end
            if sumForm == 3 or sumForm == 2 then answerForm = 0;
            elseif sumForm == 0 or sumForm == 1 then answerForm = 1; end
            if sumFill == 3 or sumFill == 2 then answerFill = 0;
            elseif sumFill == 0 or sumFill == 1 then answerFill = 1; end
            if answerRing == nil or answerForm == nil or answerFill == nil then
                return 0;
            elseif sumRing > 0 and sumRing < 3 and  sumForm > 0 and sumForm < 3 and sumFill > 0 and sumFill < 3 then
                return 0;
            else
                for index, values in pairs(table) do
                    if values.ring == answerRing and values.form == answerForm and values.fill == answerFill then
                        sendClick(values.id);
                        return winner;
                    end
                end
            end 
            return 0;
        end

    end
    if found ~= 1 then
        if found > 1 then
            print("|cff0000ffMOTSH|r |cffFF4500found " .. found .. " different solutions to the chosen symbols. Please check your symbols and try again!|r");
        end
        return 0;
    else
        return returnID;
    end
end

function reset()
    for resetter = 1, 8 do
        _G["backdrop".. resetter]:SetBackdropBorderColor(0, 0, 0, 0);
        table[resetter].selected = false;
        count = 0;
        winner = 0;
    end
end

function checkThrees(a, b, c)
    if a.ring == b.ring and c.ring ~= a.ring and a.form == b.form and c.form ~= a.form then
        return c.id;
    elseif a.ring == b.ring and c.ring ~= a.ring and a.fill == b.fill and c.fill ~= a.fill then
        return c.id;
    elseif a.fill == b.fill and c.fill ~= a.fill and a.form == b.form and c.form ~= a.form then
        return c.id;
    else
        return 0;
    end
end

function InstanceOrParty()
    if (IsInGroup(LE_PARTY_CATEGORY_INSTANCE) and (not IsInRaid())) then
        return "INSTANCE_CHAT";
    else
        return "PARTY";
    end
end

function sendClick(i)
    if GetNumGroupMembers() == 0 then
        updateUI(i);
    else
        local mode;
        if table[i].selected then
            mode = "UNACTIVE"
        else
            mode = "ACTIVE"
        end
        local data = 'SendButtonID|' .. buttonID_MH[i] .. '|' .. mode;
        C_ChatInfo.SendAddonMessage('MAZEHELPER', data, InstanceOrParty()); --MazeHelper Compatibility!   
        C_ChatInfo.SendAddonMessage("MOTSH", i, InstanceOrParty());
    end
end

_G["SLASH_motsh1"] = "/motsh";
SlashCmdList["motsh"] = function(cmd)
	UIConfig:SetShown(not UIConfig:IsVisible());
end
